# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free
%define namedversion 1.2.0-m1

Summary:        Shiro security framework
Name:           apache-shiro
Version:        1.1.0
Release:        1%{?dist}
Epoch:          0
Group:          Development/Java
License:        Apache License 2.0
URL:            http://shiro.apache.org
Source0:        http://www.apache.org/dist//shiro/1.1.0/shiro-root-1.1.0-source-release.zip
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml

Patch0:         apache-shiro-core-pom.patch
Patch1:         apache-shiro-web-pom.patch
Patch2:         apache-shiro-support-aspectj-pom.patch
Patch3:         apache-shiro-support-ehcache-pom.patch
Patch4:         apache-shiro-support-quartz-pom.patch
Patch5:         apache-shiro-support-spring-pom.patch
Patch6:         apache-shiro-samples-pom.patch
Patch7:         apache-shiro-samples-spring-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  mojo-maven2-plugin-aspectj
BuildRequires:  mojo-maven2-plugin-exec
BuildRequires:  apache-rat
BuildRequires:  easymock2
BuildRequires:  hc-project
BuildRequires:  htmlunit2
BuildRequires:  james-project
BuildRequires:  jetty6-jsp-2.1
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  junit4
BuildRequires:  oss-parent
BuildRequires:  servlet_2_5_api
BuildRequires:  spring3-test

BuildRequires:  aspectj
BuildRequires:  ehcache-core >= 0:2.2
BuildRequires:  groovy17
BuildRequires:  hsqldb
BuildRequires:  jetty6
BuildRequires:  quartz
BuildRequires:  spring3-context
BuildRequires:  spring3-jdbc
BuildRequires:  spring3-orm
BuildRequires:  spring2-webmvc

Requires:  java >= 0:1.6.0
Requires:  aspectj
Requires:  ehcache-core >= 0:2.2
Requires:  groovy17
Requires:  jetty6
Requires:  quartz
Requires:  spring3-context
Requires:  spring3-jdbc
Requires:  spring3-orm

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache Shiro is a powerful and easy-to-use Java security 
framework that performs authentication, authorization, 
cryptography, and session management. With Shiro.s 
easy-to-understand API, you can quickly and easily 
secure any application . from the smallest mobile 
applications to the largest web and enterprise 
applications.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
%{summary}.

%prep
%setup -q -n shiro-root-%{version}
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
%patch6 -b .sav6
%patch7 -b .sav7

%build
cp %{SOURCE2} settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DobrRepository=NONE \
        install 

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-root.pom
%add_to_maven_depmap org.apache.shiro shiro-root %{version} JPP/%{name} root

install -m 644 all/target/shiro-all-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/all-%{version}.jar
install -m 644 all/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-all.pom
%add_to_maven_depmap org.apache.shiro shiro-all %{version} JPP/%{name} all

install -m 644 core/target/shiro-core-%{version}-tests.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-tests-%{version}.jar
install -m 644 core/target/shiro-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
%add_to_maven_depmap org.apache.shiro shiro-core %{version} JPP/%{name} core

install -m 644 samples/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples.pom
%add_to_maven_depmap org.apache.shiro.samples shiro-samples %{version} JPP/%{name} samples

install -m 644 samples/aspectj/target/samples-aspectj-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples-aspectj-%{version}.jar
install -m 644 samples/aspectj/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples-aspectj.pom
%add_to_maven_depmap org.apache.shiro.samples samples-aspectj %{version} JPP/%{name} samples-aspectj

install -m 644 samples/quickstart/target/samples-quickstart-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples-quickstart-%{version}.jar
install -m 644 samples/quickstart/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples-quickstart.pom
%add_to_maven_depmap org.apache.shiro.samples samples-quickstart %{version} JPP/%{name} samples-quickstart

install -m 644 support/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-support.pom
%add_to_maven_depmap org.apache.shiro shiro-support %{version} JPP/%{name} support

install -m 644 support/aspectj/target/shiro-aspectj-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aspectj-%{version}.jar
install -m 644 support/aspectj/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aspectj.pom
%add_to_maven_depmap org.apache.shiro shiro-aspectj %{version} JPP/%{name} aspectj

install -m 644 support/ehcache/target/shiro-ehcache-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/ehcache-%{version}.jar
install -m 644 support/ehcache/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ehcache.pom
%add_to_maven_depmap org.apache.shiro shiro-ehcache %{version} JPP/%{name} ehcache

install -m 644 support/groovy/target/shiro-groovy-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/groovy-%{version}.jar
install -m 644 support/groovy/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-groovy.pom
%add_to_maven_depmap org.apache.shiro shiro-groovy %{version} JPP/%{name} groovy

install -m 644 support/quartz/target/shiro-quartz-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/quartz-%{version}.jar
install -m 644 support/quartz/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-quartz.pom
%add_to_maven_depmap org.apache.shiro shiro-quartz %{version} JPP/%{name} quartz

install -m 644 support/spring/target/shiro-spring-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/spring-%{version}.jar
install -m 644 support/spring/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spring.pom
%add_to_maven_depmap org.apache.shiro shiro-spring %{version} JPP/%{name} spring

install -m 644 web/target/shiro-web-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/web-%{version}.jar
install -m 644 web/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-web.pom
%add_to_maven_depmap org.apache.shiro shiro-web %{version} JPP/%{name} web

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 samples/web/target/samples-web-%{version}.war $RPM_BUILD_ROOT%{_datadir}/%{name}


# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/%{name}
%{_datadir}/maven2/poms
%{_mavendepmapfragdir}
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog
* Mon Oct 03 2011 Ralph Apel <r.apel at r-apel.de> 0:1.1.0-1
- Initial release

